﻿#pragma once

#define MAX_NEIGHBOR 8
#define WEIGHTING 1

//definition constants of which instance will be executed
//run only one at a time
#define execInst1 1
//#undef execInst1
#define execInst2 1
#undef execInst2
#define execInst3 1
#undef execInst3
#define execInst4 1
#undef execInst4
#define execInst5 1
#undef execInst5
#define execInst6 1
#undef execInst6

#ifdef execInst1
	#define NUM_DIST_MAX_NEIGHBOR 43 //for vertices with pixel of 30m
	#define NUM_VERTEX 1836
	#define NUM_VERTEX_PPA 170
	#define NUM_VERTEX_INUND 477
	#define NUM_SOURCERIVER 0 
	#undef NUM_SOURCERIVER
	#define NUM_TREE 559
	#define NUM_TURN 559 //SUM of Source River and tree
	#define NUM_SIZE_BUCKET 7345 //(NUM_DIST_MAX_NEIGHBOR / 10) * NUM_VERTEX + 1
	#define INST_COMPANY 1
	#define NUM_VERTEX_COMPANY 36
#endif

#ifdef execInst2
	#define NUM_DIST_MAX_NEIGHBOR 15 //for vertices with pixel of 10m
	#define NUM_VERTEX 16000
	#define NUM_VERTEX_PPA 1522
	#define NUM_VERTEX_INUND 4197
	#define NUM_SOURCERIVER 0 
	#undef NUM_SOURCERIVER
	#define NUM_TREE 559
	#define NUM_TURN 559 
	#define NUM_SIZE_BUCKET 24001
	#define INST_COMPANY 2
	#define NUM_VERTEX_COMPANY 109
#endif

#ifdef execInst3
	#define NUM_DIST_MAX_NEIGHBOR 43
	#define NUM_VERTEX 3726
	#define NUM_VERTEX_PPA 291
	#define NUM_VERTEX_INUND 775
	#define NUM_SOURCERIVER 1
	#define NUM_TREE 1353
	#define NUM_TURN 1354
	#define NUM_SIZE_BUCKET 14905
	#define INST_COMPANY 3
	#define NUM_VERTEX_COMPANY 80
#endif

#ifdef execInst4
	#define NUM_DIST_MAX_NEIGHBOR 15
	#define NUM_VERTEX 32800
	#define NUM_VERTEX_PPA 2677
	#define NUM_VERTEX_INUND 6700
	#define NUM_SOURCERIVER 1
	#define NUM_TREE 1353
	#define NUM_TURN 1354
	#define NUM_SIZE_BUCKET 49201
	#define INST_COMPANY 4
	#define NUM_VERTEX_COMPANY 241
#endif

#ifdef execInst5
	#define NUM_DIST_MAX_NEIGHBOR 43
	#define NUM_VERTEX 6548
	#define NUM_VERTEX_PPA 589
	#define NUM_VERTEX_INUND 915
	#define NUM_SOURCERIVER 3
	#define NUM_TREE 2424
	#define NUM_TURN 2427
	#define NUM_SIZE_BUCKET 26193
	#define INST_COMPANY 5
	#define NUM_VERTEX_COMPANY 106
#endif

#ifdef execInst6
	#define NUM_DIST_MAX_NEIGHBOR 15
	#define NUM_VERTEX 58050
	#define NUM_VERTEX_PPA 5358
	#define NUM_VERTEX_INUND 8034
	#define NUM_SOURCERIVER 3
	#define NUM_TREE 2424
	#define NUM_TURN 2427
	#define NUM_SIZE_BUCKET 87076
	#define INST_COMPANY 6
	#define NUM_VERTEX_COMPANY 320
#endif

#define NUM_ROAD 1
#define INST_G "vertices3d" //graph data file name
#define INST_TREE "ArvoresRemanescentes3d" //tree data file name
#define INST_PPA "app3d"
#define INST_INUND "verticesInund3d"
#define INST_SLOPE "verticesIncli3d"
#define INST_SOURCERIVER "nascentes3d"
#define RESUL_ROAD "resultadoRoad" //road results file name
#define SUMMARY_ROAD "consolidadoRoad" //general road file name
#define CONSTRAINT_ROAD "RoadRest"
#define SOL_ROAD "solucaoRoad"

#define AVOID_RADIUS 15
#define PENALTY_BARRIER 2
#define PENALTY_PPA 3 //10m - 3 30m - 4
#define PENALTY_SLOPE_8 1
#define PENALTY_SLOPE_10 2
#define PENALTY_SLOPE_100 2
#define PENALTY_INUND 2

#define NUM_TESTS 100

#define cDijkstra 1
#define cDijkstraOD 2
#define cbellmanFord 3
#define cDijkstraDial 4
#define cDEsopoPape 5

typedef struct area Area;

//sourceRiver structure
struct sourceRiver {
	int id;
	double x;
	double y;
	double z;
};

typedef struct sourceRiver SourceRiver;

//tree structure
struct tree {
	int id;
	int wu;
	int number;
	double DBH;
	double H;
	double basalArea;
	double volume;
	double x;
	double y;
	double z;
};

typedef struct tree Tree;

//turn structure
struct turn {
	int id;
	double x;
	double y;
	double z;
};

typedef struct turn Turn;

struct slope {
	int id;
	double x;
	double y;
	double z;
	int slopeValue;
};

typedef struct slope Slope;

struct road {
	int source;
	int end;
};

typedef struct road Road;

struct Roadsolution {
	Road road;
	double FO;
	double totalDistance;
	int routeNumVertex;
	int ancestor[NUM_VERTEX];
	int successor[NUM_VERTEX];
	double distance[NUM_VERTEX];
	double weight[NUM_VERTEX];
	double timeSol;
	double time;
	int negativeCycle;

};

typedef struct Roadsolution RoadSolution;

struct groupRoadSolution {
	RoadSolution roads[NUM_ROAD];
	int totalRouteNumVertex;
	double totalTime;
	double totalDistance;
	double TotalFO;
};

typedef struct groupRoadSolution GroupRoadSolution;

//===================================== METODOS COMMONS ======================================
Area* importGraphAreaInstance(char *file);
int* importPPAInstance(char *file);
int* importInundInstance(char *file);
Slope* importSlopeInstance(char *file);
void importSourceRiverInstance(char *file, SourceRiver *sourceRiver, Turn *turn);
void importTreesInstance(char *file, Tree *tree, Turn *turn);
int RadiusTurnSearch(Area *ar, Turn *turn, int vertex);
int PPASearch(int *PPA, int vertex);
int InundSearch(int *inund, int vertex);
int SlopeSearch(Slope *slope, int vertex);
double CalculatesDistance(Area *ar, int source, int dest, int d3);
double CalculatesPenaltyDistance(Area *ar, int source, int dest, Turn *turn, int *PPA, int *inund, Slope *slope);
void SaveResultsConstraint(GroupRoadSolution *sol, char *fileResul, Area *ar, Turn *turn, int *PPA, int *inund, Slope *slope);
void SaveResultsRoads(char *fileResul, char *fileSol, char *fileSummary, GroupRoadSolution *sol, int iter);