#include "stdafx.h"
#include <iostream>
#include <string.h>
#include <time.h>
using namespace std;
#include "ExecMHRoad.h"
#include "TimeCounter.h"

GroupRoadSolution designRoad(int algorithm, Graph *gr, Road *pRoad, char *fileResul, char *fileSol, char *fileSummary, int iter) {
	double tStart = get_time();
	int i;
	RoadSolution sol, solAux;
	GroupRoadSolution solRoad;
	double distanceRoad1, distanceRoad2, mFO;
	int vertex, mVertex;
	solRoad.totalRouteNumVertex = 0;
	solRoad.TotalFO = 0;
	solRoad.totalDistance = 0;

	for (i = 0; i < NUM_ROAD; i++) {
		if (i == 0) {
			int p = pRoad[i].source;
			int t = pRoad[i].end;
			switch (algorithm)
			{
			case cDijkstra:
				sol = Dijkstra(gr, p, t);
				break;
			case cDijkstraOD: 
				sol = DijkstraOD(gr, p, t); 
				break;
			case cbellmanFord:
				sol = bellmanford(gr, p, t);
				break;
			case cDijkstraDial:
				sol = DijkstraDial(gr, p, t);
				break;
			case cDEsopoPape:
				sol = DEsopoPape(gr, p, t);
				break;
			default:
				sol = Dijkstra(gr, p, t);
				break;
			};
		}
		else {
			if (pRoad[i].source != pRoad[i - 1].source) {
				switch (algorithm)
				{
				case cDijkstra:
					sol = Dijkstra(gr, pRoad[i].source, pRoad[i].end);
					break;
				case cDijkstraOD:
					sol = DijkstraOD(gr, pRoad[i].source, pRoad[i].end);
					break;
				case cbellmanFord:
					sol = bellmanford(gr, pRoad[i].source, pRoad[i].end);
					break;
				case cDijkstraDial:
					sol = DijkstraDial(gr, pRoad[i].source, pRoad[i].end);
					break;
				case cDEsopoPape:
					sol = DEsopoPape(gr, pRoad[i].source, pRoad[i].end);
					break;
				default:
					sol = Dijkstra(gr, pRoad[i].source, pRoad[i].end);
					break;
				};
			}
			else {
				//the origin is the same, in this case test the combinations
				//take the distance of section 1 and section 2
				distanceRoad1 = sol.FO;
				distanceRoad2 = sol.weight[pRoad[i].end];
				//add the two distances to get the total
				mFO = distanceRoad1 + distanceRoad2;
				//assigns the current start vertex to be the best one so far
				mVertex = sol.road.source;
				//evaluates combinations
				//get the predecessor vertex stretch to evaluate their combinations
				vertex = sol.ancestor[sol.road.end];
				do {
					switch (algorithm)
					{
					case cDijkstra:
						sol = Dijkstra(gr, vertex, pRoad[i].end);
						break;
					case cDijkstraOD:
						solAux = DijkstraOD(gr, vertex, pRoad[i].end);
						break;
					case cbellmanFord:
						solAux = bellmanford(gr, vertex, pRoad[i].end);
						break;
					case cDijkstraDial:
						sol = DijkstraDial(gr, vertex, pRoad[i].end);
						break;
					case cDEsopoPape:
						sol = DEsopoPape(gr, vertex, pRoad[i].end);
						break;
					default:
						solAux = Dijkstra(gr, vertex, pRoad[i].end);
						break;
					};

					//updates the distance of section 2 with the starting point being the vertex being analyzed
					distanceRoad2 = solAux.FO;
					//checks if the distance has minimized in relation to the two separate roads
					if ((distanceRoad1 + distanceRoad2) < mFO) {
						//if yes, it updates the best vertex and the best distance
						mVertex = vertex;
						mFO = distanceRoad1 + distanceRoad2;
					}
					//obtain the predecessor vertex of the section to evaluate its combination
					vertex = sol.ancestor[vertex];
				} while (vertex != -1); //continues as long as the entire previous section is not evaluated
				//after evaluating all combinations, check if the best vertex has changed
				if (mVertex != sol.road.source) {
					//if so, update the start vertex and invoke Dijkstra again with the new start vertex
					pRoad[i].source = mVertex;
				}

				switch (algorithm)
				{
				case cDijkstra:
					sol = Dijkstra(gr, pRoad[i].source, pRoad[i].end);
					break;
				case cDijkstraOD:
					sol = DijkstraOD(gr, pRoad[i].source, pRoad[i].end);
					break;
				case cbellmanFord:
					sol = bellmanford(gr, pRoad[i].source, pRoad[i].end);
					break;
				case cDijkstraDial:
					sol = DijkstraDial(gr, pRoad[i].source, pRoad[i].end);
					break;
				case cDEsopoPape:
					sol = DEsopoPape(gr, pRoad[i].source, pRoad[i].end);
					break;
				default:
					sol = Dijkstra(gr, pRoad[i].source, pRoad[i].end);
					break;
				};
			}
		}
		solRoad.roads[i] = sol;
		solRoad.totalRouteNumVertex += sol.routeNumVertex;
		solRoad.TotalFO += sol.FO;
		solRoad.totalDistance += sol.totalDistance;
	}
	solRoad.totalTime = (get_time() - tStart) / 100.0;
	SaveResultsRoads(fileResul, fileSol, fileSummary, &solRoad, iter);
	return solRoad;
}