#include "stdafx.h"
#include <iostream>
#include <time.h>
#include "TimeCounter.h"

using namespace std;

typedef struct timeval{
	long tv_sec;
	long tv_usec;
} timeval;

int gettimeofday(struct timeval * tp, struct timezone * tzp)
{
	// Note: some broken versions only have 8 trailing zero's, the correct epoch has 9 trailing zero's
	// This magic number is the number of 100 nanosecond intervals since January 1, 1601 (UTC)
	// until 00:00:00 January 1, 1970 
	static const uint64_t EPOCH = ((uint64_t)116444736000000000ULL);

	SYSTEMTIME  system_time;
	FILETIME    file_time;
	uint64_t    time;

	GetSystemTime(&system_time);
	SystemTimeToFileTime(&system_time, &file_time);
	time = ((uint64_t)file_time.dwLowDateTime);
	time += ((uint64_t)file_time.dwHighDateTime) << 32;

	tp->tv_sec = (long)((time - EPOCH) / 10000000L);
	tp->tv_usec = (long)(system_time.wMilliseconds * 1000);
	return 0;
}

double get_time() {
	struct timeval tv;
	gettimeofday(&tv, 0);
	return (double)(tv.tv_sec*100.0 + tv.tv_usec / 10000.0);
};

void printTime() {
	struct tm *currentDateTime;
	time_t seconds;
	time(&seconds);
	currentDateTime = localtime(&seconds);
	cout << "Hora ........: " << currentDateTime->tm_hour << ":" << currentDateTime->tm_min << ":" << currentDateTime->tm_sec << endl;//hora
}

void printDateTime() {
	struct tm *currentDateTime;
	time_t seconds;
	time(&seconds);
	currentDateTime = localtime(&seconds);
	cout << "Data ........: " << currentDateTime->tm_mday << "/" << currentDateTime->tm_mon + 1 << "/" << currentDateTime->tm_year + 1900 << endl;//hora
	cout << "Hora ........: " << currentDateTime->tm_hour << ":" << currentDateTime->tm_min << ":" << currentDateTime->tm_sec << endl;//hora
}